commit 0f0c24cf9622a3c74574a0e2d2bb2f51fed3e773
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Wed Nov 17 17:31:40 2021

    libcpp: Fix up handling of block comments in -fdirectives-only mode [PR103130]
    
    Normal preprocessing, -fdirectives-only preprocessing before the Nathan's
    rewrite, and all other compilers I've tried on godbolt treat even \*/
    as end of a block comment, but the new -fdirectives-only handling doesn't.
    
    2021-11-17  Jakub Jelinek  <jakub@redhat.com>
    
            PR preprocessor/103130
            * lex.c (cpp_directive_only_process): Treat even \*/ as end of block
            comment.
    
            * c-c++-common/cpp/dir-only-9.c: New test.
    
    (cherry picked from commit 049f0efeaa77b43a508172161ca040feb6bb5622)

diff --git a/gcc/testsuite/c-c++-common/cpp/dir-only-9.c b/gcc/testsuite/c-c++-common/cpp/dir-only-9.c
new file mode 100644
index 00000000000..d11cd97cb71
--- /dev/null
+++ b/gcc/testsuite/c-c++-common/cpp/dir-only-9.c
@@ -0,0 +1,13 @@
+/* PR preprocessor/103130 */
+/* { dg-do preprocess } */
+/* { dg-options -fdirectives-only } */
+
+/*\
+ * this is a comment
+\*/
+
+int
+main ()
+{
+  return 0;
+}
diff --git a/libcpp/lex.c b/libcpp/lex.c
index 3791f388207..69dfb4ebb76 100644
--- a/libcpp/lex.c
+++ b/libcpp/lex.c
@@ -4453,7 +4453,7 @@ cpp_directive_only_process (cpp_reader *pfile,
 			break;
 
 		      case '*':
-			if (pos > peek && !esc)
+			if (pos > peek)
 			  star = is_block;
 			esc = false;
 			break;

